mod Ex09 logic: 'cl'

incl Mtex

incl Mtexbt

incl Mtexg

incl Maux

loc rem 
  \para \bf  9. CVICENIE Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end streda 9.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  [CL] Remark.  \end The module \it  Mlogicq  \end in the file \it  
  mlogicq.cl  \end contains the syntax of quantifier tableau rules. The module 
  \it  Mlogicd  \end in the file \it  mlogicd.cl  \end contains the syntax of 
  derived tableau rules. The module \it  Mlogicpa  \end in the file \it  
  mlogicpa.cl  \end contains the syntax of arithmetic tableau rules and built-in 
  properties of the pre-defined functions and predicates in the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Trees.  \end 

rem 
  \para \bf  Arithmetization of labelled binary trees.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

rem 
  \para \bf  Binary trees.  \end 

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \bf  [CL] Formatting the output.  \end Use the format \ft Bt \end to 
  display numbers as binary trees. Try out the following simple queries 
  \verbatim 
      171386336145149 = t:Bt
  \end
  \verbatim 
      1,10,(1,11,(0,0),0,0),(1,12,(0,0),0,0) = t:Bt
  \end

rem 
  \para \bf  [CL] Structural case analysis on binary trees.  \end Syntax: 
  \eq* 
    'case Bt ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(Bt,t) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_assum Bt(t),
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,E),
                                              Tex_f1_g_x_assum Tex_f2_g_and(Tex_f2_g_eq(t,
                                                                                        Nd(x,
                                                                                           l,
                                                                                           r)),
                                                                            Tex_f2_g_and(Bt(l),
                                                                                         Bt(r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Structural induction on binary trees.  \end Show that the principle 
  of structural induction over binary_trees is admissible in Peano arithmetic. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  [CL] Hint.  \end Reduce structural induction on \ft t \end to 
  course of values induction with measure \ft |t| \end. Recall that the pair 
  size function \ft |x| \end, written as \it  |x|  \end, is defined in the 
  module \it  Standard  \end. 

theory Structural_induction_on_binary_trees

pred A 'Tex_p1_phi_subst'

axiom Base_case
  A(E)

axiom Induction_step
  A(l) & A(r) -> A Nd(x,l,r)

thm Conclusion
  Bt(t) -> A(t)

end theory Structural_induction_on_binary_trees

rem 
  \para \bf  [CL] Structural induction on binary trees.  \end Syntax: 
  \eq* 
    'ind Bt ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Bt,t) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex2_bappl1(Tex0_phi,
                                                                                                    l),
                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                    r)),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(Bt,t),a) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex_f2_g_forall(a,
                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                    l)),
                                                                                        Tex_f2_g_forall(a,
                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                    r))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  [CL] Structural induction on binary trees (2nd form).  \end Syntax: 
  \eq* 
    'ind* Bt ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_inds Tex_f2_g_x_sc(Bt,t) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Bt(l),
                                                                                        Tex_f2_g_and(Tex2_bappl1(Tex0_phi,
                                                                                                                 l),
                                                                                                     Tex_f2_g_and(Bt(r),
                                                                                                                  Tex2_bappl1(Tex0_phi,
                                                                                                                              r)))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
   \item \para \ft Tex_f1_g_x_inds Tex_f2_g_x_sc(Tex_f2_g_x_sc(Bt,t),a) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Bt(t),
                                                         Tex2_bappl1(Tex0_phi,t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          E),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Bt(l),
                                                                                        Tex_f2_g_and(Tex_f2_g_forall(a,
                                                                                                                     Tex2_bappl1(Tex0_phi,
                                                                                                                                 l)),
                                                                                                     Tex_f2_g_and(Bt(r),
                                                                                                                  Tex_f2_g_forall(a,
                                                                                                                                  Tex2_bappl1(Tex0_phi,
                                                                                                                                              r))))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       Nd(x,
                                                                                          l,
                                                                                          r)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end, \ft l \end and \ft r \end are new variables 
         \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Size and depth of binary trees.  \end 

fun Sz 'Tex_f1_bt_sz'
  Sz(E) = 0
  Sz Nd(x,l,r) = Sz(l)+Sz(r)+1

fun Dp 'Tex_f1_bt_dp'
  Dp(E) = 0
  Dp Nd(x,l,r) = Max(Dp(l),Dp(r))+1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Sz(t) = 0 <-> t = E
  \end
  \eq* 
    Bt(t) -> Dp(t) = 0 <-> t = E
  \end
  \para \it  Hint.  \end By structural case analysis on the binary tree 
  \ft t \end. 

thm Sz_is_zero
  Bt(t) -> Sz(t) = 0 <-> t = E

thm Dp_is_zero
  Bt(t) -> Dp(t) = 0 <-> t = E

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))
  \end
  \para \it  [CL] Hint.  \end You will need the theorem \it  Exp_cancel_le  \end 
  from the module \it  Maux  \end. 

thm Dp_sz
  Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))

rem 
  \para \bf  Membership in binary trees.  \end 

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,Nd(y,l,r)) <- x = y
  Inbt(x,Nd(y,l,r)) <- x != y & Inbt(x,l)
  Inbt(x,Nd(y,l,r)) <- x != y & ~Inbt(x,l) & Inbt(x,r)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    ~Inbt(x,E)
  \end
  \eq* 
    Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)
  \end

thm Inbt_e
  ~Inbt(x,E)
proof  proved.

thm Inbt_nd
  Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)

rem 
  \para \bf  Reflection function.  \end 

fun Reflect 
  Reflect(E) = E
  Reflect Nd(x,l,r) = Nd(x,Reflect(r),Reflect(l))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Bt Reflect(t)
  \end
  \eq* 
    Bt(t) -> Inbt(x,Reflect(t)) <-> Inbt(x,t)
  \end
  \eq* 
    Bt(t) -> Sz Reflect(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> Dp Reflect(t) = Dp(t)
  \end
  \eq* 
    Bt(t) -> Reflect Reflect(t) = t
  \end
  \eq* 
    Bt(t1) & Bt(t2) & Reflect(t1) = Reflect(t2) -> t1 = t2
  \end
  \eq* 
    Bt(t1) -> \e t2 Reflect(t2) = t1
  \end

thm Reflect_bt
  Bt(t) -> Bt Reflect(t)

thm Reflect_inbt
  Bt(t) -> Inbt(x,Reflect(t)) <-> Inbt(x,t)

thm Reflect_sz
  Bt(t) -> Sz Reflect(t) = Sz(t)

thm Reflect_dp
  Bt(t) -> Dp Reflect(t) = Dp(t)

thm Reflect_reflect
  Bt(t) -> Reflect Reflect(t) = t

thm Reflect_injective
  Bt(t1) & Bt(t2) & Reflect(t1) = Reflect(t2) -> t1 = t2

thm Reflect_surjective
  Bt(t1) -> \e t2 Reflect(t2) = t1

rem 
  \para \bf  Traversals of binary trees.  \end 

fun Preorder 
  Preorder(E) = 0
  Preorder Nd(x,l,r) = x,Preorder(l)++Preorder(r)

fun Inorder 
  Inorder(E) = 0
  Inorder Nd(x,l,r) = Inorder(l)++(x,Inorder(r))

fun Postorder 
  Postorder(E) = 0
  Postorder Nd(x,l,r) = Postorder(l)++Postorder(r)++(x,0)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> L Preorder(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> x in Preorder(t) <-> Inbt(x,t)
  \end
  \eq* 
    Bt(t) -> L Inorder(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> x in Inorder(t) <-> Inbt(x,t)
  \end
  \eq* 
    Bt(t) -> L Postorder(t) = Sz(t)
  \end
  \eq* 
    Bt(t) -> x in Postorder(t) <-> Inbt(x,t)
  \end

thm Preorder_m
  Bt(t) -> L Preorder(t) = Sz(t)

thm Preorder_inbt
  Bt(t) -> x in Preorder(t) <-> Inbt(x,t)

thm Inorder_m
  Bt(t) -> L Inorder(t) = Sz(t)

thm Inorder_inbt
  Bt(t) -> x in Inorder(t) <-> Inbt(x,t)

thm Postorder_m
  Bt(t) -> L Postorder(t) = Sz(t)

thm Postorder_inbt
  Bt(t) -> x in Postorder(t) <-> Inbt(x,t)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Preorder(t) = Rev Postorder Reflect(t)
  \end
  \eq* 
    Bt(t) -> Postorder(t) = Rev Preorder Reflect(t)
  \end

thm Preorder_postorder
  Bt(t) -> Preorder(t) = Rev Postorder Reflect(t)

thm Postorder_preorder
  Bt(t) -> Postorder(t) = Rev Preorder Reflect(t)

rem 
  \para \bf  Fast programs for tree traversals.  \end 

rem 
  \para \bf  Case: preorder traversal.  \end 

fun/2 Preordera 'Tex_f2_f'
  Preordera(E,a) = a
  Preordera(Nd(x,l,r),a) = x,Preordera(l,Preordera(r,a))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Bt(t) -> Preorder(t) = Preordera(t,0)
  \end

thm Preorder_by_preordera
  Bt(t) -> Preorder(t) = Preordera(t,0)

rem 
  \para \bf  Case: inorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Save the concatenation in the definition of the 
  function \ft Inorder(t) \end with help of an accumulator function and verify 
  your implementation. 

rem 
  \para \bf  Case: postorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Save the concatenation in the definition of the 
  function \ft Postorder(t) \end with help of an accumulator function and verify 
  your implementation. 

rem 
  \para \bf  Full binary trees.  \end A binary tree \ft t \end is said to be 
  \it  full  \end if 
  \eq* 
    Sz(t)+1 = Exp(2,Dp(t))
  \end

rem 
  \para \bf  Exercise.  \end \header* fun/2 Fs 'Tex_f2_f' \end Define the 
  function \ft Fs(n,x) \end such that 
  \eq* 
    Bt Fs(n,x)
  \end
  \eq* 
    Dp Fs(n,x) = n
  \end
  \eq* 
    Sz Fs(n,x)+1 = Exp(2,n)
  \end
  \eq* 
    Inbt(y,Fs(n,x)) -> y = x
  \end

fun/2 Fs 'Tex_f2_f'
  Fs(n,x) = Foo

thm Fs_bt
  Bt Fs(n,x)

thm Fs_dp
  Dp Fs(n,x) = n

thm Fs_sz
  Sz Fs(n,x)+1 = Exp(2,n)

thm Fs_inbt
  Inbt(y,Fs(n,x)) -> y = x
proof  proved.

rem 
  \para \bf  Exercise.  \end \header* fun Fpr 'Tex_f1_f' \end Define the 
  function \ft Fpr(n) \end such that 
  \eq* 
    Bt Fpr(n)
  \end
  \eq* 
    Dp Fpr(n) = n
  \end
  \eq* 
    Sz Fpr(n)+1 = Exp(2,n)
  \end
  \eq* 
    Preorder Fpr(n) = Interval(0,Exp(2,n)-1)
  \end
  \para \it  Hint.  \end \header* fun/2 Fpr1 'Tex_f2_g' \end Define first an 
  auxiliary function \ft Fpr1(n,m) \end such that 
  \eq* 
    Bt Fpr1(n,m)
  \end
  \eq* 
    Dp Fpr1(n,m) = n
  \end
  \eq* 
    Sz Fpr1(n,m)+1 = Exp(2,n)
  \end
  \eq* 
    Preorder Fpr1(n,m) = Interval(m,m+Exp(2,n)-1)
  \end

fun/2 Fpr1 'Tex_f2_g'
  Fpr1(n,m) = Foo

fun Fpr 'Tex_f1_f'
  Fpr(n) = Foo

lemma Fpr1_bt
  Bt Fpr1(n,m)

lemma Fpr1_dp
  Dp Fpr1(n,m) = n

lemma Fpr1_sz
  Sz Fpr1(n,m)+1 = Exp(2,n)

lemma Fpr1_preorder
  Preorder Fpr1(n,m) = Interval(m,m+Exp(2,n)-1)

thm Fpr_bt
  Bt Fpr(n)

thm Fpr_dp
  Dp Fpr(n) = n

thm Fpr_sz
  Sz Fpr(n)+1 = Exp(2,n)

thm Fpr_preorder
  Preorder Fpr(n) = Interval(0,Exp(2,n)-1)

rem 
  \para \bf  Exercise.  \end \header* fun Fin 'Tex_f1_f' \end Define the 
  function \ft Fin(n) \end such that 
  \eq* 
    Bt Fin(n)
  \end
  \eq* 
    Dp Fin(n) = n
  \end
  \eq* 
    Sz Fin(n)+1 = Exp(2,n)
  \end
  \eq* 
    Inorder Fin(n) = Interval(0,Exp(2,n)-1)
  \end

fun Fin 'Tex_f1_f'
  Fin(n) = Foo

thm Fin_bt
  Bt Fin(n)

thm Fin_dp
  Dp Fin(n) = n

thm Fin_sz
  Sz Fin(n)+1 = Exp(2,n)

thm Fin_inorder
  Inorder Fin(n) = Interval(0,Exp(2,n)-1)

rem 
  \para \bf  Exercise.  \end \header* fun Fpo 'Tex_f1_f' \end Define the 
  function \ft Fpo(n) \end such that 
  \eq* 
    Bt Fpo(n)
  \end
  \eq* 
    Dp Fpo(n) = n
  \end
  \eq* 
    Sz Fpo(n)+1 = Exp(2,n)
  \end
  \eq* 
    Postorder Fpo(n) = Interval(0,Exp(2,n)-1)
  \end

fun Fpo 'Tex_f1_f'
  Fpo(n) = Foo

thm Fpo_bt
  Bt Fpo(n)

thm Fpo_dp
  Dp Fpo(n) = n

thm Fpo_sz
  Sz Fpo(n)+1 = Exp(2,n)

thm Fpo_postorder
  Postorder Fpo(n) = Interval(0,Exp(2,n)-1)

